var appController;
var locationsArticleReference = new Object();
var googleAnalytics = null;
var fileSystem = null;
var theAppIsBusy = false;


var application = {

    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },

    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
        document.addEventListener('offline', this.onOffline, false);
    },

    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicity call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        application.receivedEvent('deviceready');
    },

    // Update DOM on a Received Event
    receivedEvent: function(id) {
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 15*1024*1024, $.proxy(this.fileSystemSuccess, this), $.proxy(this.fileSystemFail, this));

        googleAnalytics = new AREGoogleAnalytics();
        googleAnalytics.setupWithKey("UA-45097381-18");
    },

    fileSystemSuccess: function(fs) {
        fileSystem = fs;
        $(document).ready($.proxy(this.startApplication, this));
    },

    fileSystemFail: function(fs) {
        fileSystem = null;
        $(document).ready($.proxy(this.startApplication, this));
    },

    startApplication : function() {
        appController = new AREApplicationController();
    },

    onOffline : function() {
        if (AREModalView.sharedInstance) {
            var n = new ARENotificationView({heading:"CONNECTION ISSUE",body:"You are not connected to the internet, some features may not be available until you reconnect."});
            AREModalView.sharedInstance.displayNotification(n);
        }
    }
};

