AREPageViewController.prototype = new AREViewController();
AREPageViewController.prototype.constructor = AREPageViewController;

function AREPageViewController() {
	this.views = new Array();
	this.currentView = null;
	this.nextView = null;

	AREViewController.prototype.constructor.call(this);
}

AREPageViewController.prototype.setView = function(v) {
	this.views = new Array();
	this.view.addSubview(v);
	$(this.view.html).ready($.proxy(this.viewReady, this, [v]));
	this.views.push(v);
	this.currentView = v;
}

AREPageViewController.prototype.pushView = function(v, dontCallReady) {
	if (this.views.length <= 0) {
		this.view.addSubview(v);
		if(!dontCallReady) {
			$(this.view.html).ready($.proxy(this.viewReady, this, [v]));
		}
		this.views.push(v);
		this.currentView = v;
	} else {
		v.x("100%");
		this.nextView = v;
		this.view.addSubview(v);
		$(this.view.html).ready($.proxy(this.beginPushPageTransition, this));
		this.views.push(v);
	}
}

AREPageViewController.prototype.popView = function(v, dontCallReady) {
	if (this.views.length <= 0) {
		this.view.addSubview(v);
		if(!dontCallReady) {
			$(this.view.html).ready($.proxy(this.viewReady, this, [v]));
		}
		this.views.push(v);
		this.currentView = v;
	} else {
		v.x("-100%");
		this.nextView = v;
		this.view.addSubview(v);
		$(this.view.html).ready($.proxy(this.beginPopPageTransition, this));
		this.views.push(v);
	}
}

AREPageViewController.prototype.beginPushPageTransition = function() {
	if (this.nextView) AREAnimation.to(this.nextView.html, 0.8, {left:"0px", ease:"Expo.easeInOut"});
	if (this.currentView) AREAnimation.to(this.currentView.html, 0.8, {left:"-100%", ease:"Expo.easeInOut", delay:0.1, onComplete:$.proxy(this.transitionComplete, this)});
}

AREPageViewController.prototype.beginPopPageTransition = function() {
	if (this.nextView) AREAnimation.to(this.nextView.html, 0.8, {left:"0px", ease:"Expo.easeInOut"});
	if (this.currentView) AREAnimation.to(this.currentView.html, 0.8, {left:"100%", ease:"Expo.easeInOut", delay:0.1, onComplete:$.proxy(this.transitionComplete, this)});
}

AREPageViewController.prototype.transitionComplete = function() {
	var index = this.views.indexOf(this.currentView);
	this.views.splice(index, 1);

	this.currentView.removeFromSuperview();
	this.currentView = null;
	this.currentView = this.nextView;
	this.nextView = null;
	this.viewReady(this.currentView);
}

AREPageViewController.prototype.viewReady = function(v) {

	// var iOS = /(iPad|iPhone|iPod)/g.test( navigator.userAgent );
	// if (iOS) {
	// 	if (this.currentView) this.currentView.viewAdded();
	// }
	// alert("Breakpoint D1");
	// if (this.currentView) this.currentView.viewAdded();
	$(this).trigger(AREPageViewControllerEvent.PAGE_READY);
	// alert("Breakpoint D2");
}