var AREGoogleAnalytics = function() {
	this.plugin = window.plugins.gaPlugin;
	this.key = null;
	this.uploadDelay = 30;
}

AREGoogleAnalytics.prototype.setupWithKey = function(key) {
	this.key = key;

	this.plugin.init($.proxy(this.nativePluginResultHandler, this), $.proxy(this.nativePluginErrorHandler, this), this.key, this.uploadDelay);
	// navigator.notification.confirm("Google Analytics would like your permission to collect usage data. No personal or user identifiable data will be collected.", $.proxy(this.permissionCallback, this), "Attention", "Allow,Deny");
}

AREGoogleAnalytics.prototype.permissionCallback = function(button) {
	if (button == 1) {
		this.plugin.init($.proxy(this.nativePluginResultHandler, this), $.proxy(this.nativePluginErrorHandler, this), this.key, this.uploadDelay);
	} else {
		console.log("permission denied");
	}
}

AREGoogleAnalytics.prototype.nativePluginResultHandler = function(result) {
	 //alert('nativePluginResultHandler - '+result);
	 console.log("nativePluginResultHandler: "+result);
}

AREGoogleAnalytics.prototype.nativePluginErrorHandler = function(error) {
	//alert('nativePluginErrorHandler - '+error);
	console.log("nativePluginErrorHandler: "+error);
}

AREGoogleAnalytics.prototype.trackPage = function(pageTitle) {
	if (this.plugin) this.plugin.trackPage($.proxy(this.nativePluginResultHandler, this), $.proxy(this.nativePluginErrorHandler, this), pageTitle);
}

AREGoogleAnalytics.prototype.trackEvent = function(eventCategory, eventAction, eventLabel, eventValue) {
	//		1)  eventCategory - This is the type of event you are sending such as "Button", "Menu", etc.
	//		2)  eventAction - This is the type of event you are sending such as "Click", "Select". etc.
	//		3)  eventLabel - A label that describes the event such as Button title or Menu Item name.
	//		4)  eventValue - An application defined integer value that can mean whatever you want it to mean.

	if (this.plugin) this.plugin.trackEvent($.proxy(this.nativePluginResultHandler, this), $.proxy(this.nativePluginErrorHandler, this), eventCategory, eventAction, eventLabel, eventValue);
}

AREGoogleAnalytics.prototype.trackData = function(dataValue, slotIndex) {
	//		1)  index - the numerical index representing one of your variable slots (1-20).
	//		2)  value - Arbitrary string data associated with the index.

	if (this.plugin) this.plugin.setVariable($.proxy(this.nativePluginResultHandler, this), $.proxy(this.nativePluginErrorHandler, this), slotIndex, dataValue);
}

AREGoogleAnalytics.prototype.applicationExit = function() {
	if (this.plugin) this.plugin.exit($.proxy(this.nativePluginResultHandler, this), $.proxy(this.nativePluginErrorHandler, this));
}