AREArticleContentView.prototype = new AREContentView();
AREArticleContentView.prototype.constructor = AREArticleContentView;

function AREArticleContentView(obj) {
	this.articleData = obj;
	this.articleHeaderElement = null;
	this.articleContentElement = null;
	this.articleImageBackground = null;
	this.articleContainer = null;
	this.imageContainer = null;

	AREContentView.prototype.constructor.call(this);
}

AREArticleContentView.prototype.drawView = function() {
	AREContentView.prototype.drawView.call(this);
	this.addViewClass("articleView");
	$(this.html).removeClass("view");

	if (this.articleData.background) {
		this.articleImageBackground = new AREView();
		this.articleImageBackground.html = "<img src='"+this.articleData.background+"' class='articleBackgroundImage'>";
		this.addSubview(this.articleImageBackground);
	}

	this.articleContainer = new AREView();
	this.articleContainer.addViewClass("articleContainer");
	this.addSubview(this.articleContainer);

	this.articleHeaderElement = new AREView(null, "h1");
	this.articleHeaderElement.setHtml(this.articleData.title);
	this.articleContainer.addSubview(this.articleHeaderElement);

	if (this.articleData.images) {
		if (this.articleData.images.length > 0) {
			this.imageContainer = new AREView();
			this.imageContainer.addViewClass("imageContent");
			$(this.imageContainer.html).removeClass("view");
			this.articleContainer.addSubview(this.imageContainer);

			for (var i=0; i<this.articleData.images.length; i++) {
				var imgSrc = this.articleData.images[i];
				var image = new AREArticleContentThumbnailView(new AREImage(imgSrc).getImage());
				this.imageContainer.addSubview(image);
			}
		}
	}

	this.articleContentElement = new AREView();
	$(this.articleContentElement.html).removeClass("view");
	this.articleContentElement.addViewClass("articleBody");
	this.articleContentElement.setHtml(this.articleData.content);
	this.articleContainer.addSubview(this.articleContentElement);

	// if (this.articleData.images) {
	// 	if (this.articleData.images.length > 0) {
	// 		this.articleContentElement.addViewClass("reducedContent");
	// 	}
	// } //NOT USING THIS ANYMORE, NOW WORD-WRAPPING WILL DO ITS JOB IF NECESSARY

	// if (this.articleData.background) this.addBackgroundImage(this.articleData.background);


}

// AREArticleContentView.prototype.addBackgroundImage = function(u) {
// 	// $(this.articleImageBackground.html).css("background-image","url("+new AREImage(u).getImage()+")");
// 	$(this.articleImageBackground.html).append("<img src='"+new AREImage(u).getImage()+"' class='articleHeaderImage'>");

// 	var backgroundImage = $(this.articleImageBackground.html).children('img')[0];

// 	var articleHeaderContent = this.articleContainer.html;

// 	$(backgroundImage).load(function() {
// 		var bgMarginTop = (backgroundImage.clientHeight - (backgroundImage.clientHeight/5)) + "px";

// 		if (backgroundImage.clientHeight == 0) {
// 			$(articleHeaderContent).css( "margin-top" , "300px" );
// 		} else {
// 			$(articleHeaderContent).css( "margin-top" , bgMarginTop );
// 		}
// 	});

// 	window.addEventListener("orientationchange", function(){
// 		// Compute the image's height BEFORE the screen has changed
// 		var bgMarginTop1 = (backgroundImage.clientHeight - (backgroundImage.clientHeight/5)) + "px";

// 		setTimeout(function() {
// 			// Compute the image's height AFTER the screen has changed
// 			var bgMarginTop2 = (backgroundImage.clientHeight - (backgroundImage.clientHeight/5)) + "px";

// 			if (bgMarginTop2 <= bgMarginTop1) {
// 				if (backgroundImage.clientHeight == 0) {
// 					$(articleHeaderContent).css( "margin-top" , "300px" );
// 				} else {
// 					$(articleHeaderContent).css( "margin-top" , bgMarginTop2 );
// 					$(".scrollView").css("height", "100%");
// 				}
// 			} else {
// 				if (backgroundImage.clientHeight == 0) {
// 					$(articleHeaderContent).css( "margin-top" , "300px" );
// 				} else {
// 					$(articleHeaderContent).css( "margin-top" , bgMarginTop2 );
// 					// The margin-top will crop the bottom of Advert Queue, as it takes space from it, so we reserve more space for the entire Advert
// 					$(".scrollView").css("height", "150%");
// 				}
// 			}

// 		}, 500);
// 	});
// }
