AREArticleFooterContentView.prototype = new AREContentView();
AREArticleFooterContentView.prototype.constructor = AREArticleFooterContentView;

function AREArticleFooterContentView(obj) {
	this.articleData = obj;
	this.map = null;
	this.marker = null;
	AREContentView.prototype.constructor.call(this);
}

AREArticleFooterContentView.prototype.drawView = function() {
	AREContentView.prototype.drawView.call(this);
	this.addViewClass("articleFooterView");

	var container = new AREView();
	container.addViewClass("articleFooterContainer");

	var header = new AREView(null,"h1");
	header.setHtml(this.articleData.heading);
	container.addSubview(header);

	var content = new AREView(null,"p");
	content.setHtml(this.articleData.body);
	container.addSubview(content);

	var cat = this.articleData.parentAdvertQueue.parentSubCategory.parentCategory;

	var clear = new AREClear();
	container.addSubview(clear);

	var address = new AREView();
	address.addViewClass("addressContainer");
	$(address.html).html(this.articleData.address);
	container.addSubview(address);

	$(address.html).append("<br/>");

	if (this.articleData.webAddress) $(address.html).append(
		"<br/><span onclick=\"window.open('"+this.articleData.webAddress+"', '_blank', 'location=yes');\" style='text-decoration:underline;color:blue;cursor:pointer;'>"+this.articleData.webAddress+"</span>"
	);
	if (this.articleData.email) $(address.html).append("<br/>"+this.articleData.email);
	if (this.articleData.telephone) $(address.html).append("<br/>"+this.articleData.telephone);
	if (this.articleData.telephone2) $(address.html).append("<br/>"+this.articleData.telephone2);
	if (this.articleData.fax) $(address.html).append("<br/>"+this.articleData.fax);

	if (this.articleData.logo) {
		var logo = new ARESponsorView(this.articleData.logo, this.articleData.webAddress);
		logo.removeLinkIcon();
		container.addSubview(logo);
	}

	if (typeof google === 'object' && typeof google.maps === 'object' && navigator && navigator.onLine) {

		if ( (ApplicationData.sharedInstance.hasMaps) && (this.articleData.latitude != null) && (this.articleData.longitude != null) ) {
			this.map = new AREView();
			this.map.addViewClass("mapContainer");
			container.addSubview(this.map);
		}
	}

	this.addSubview(container);
}

AREArticleFooterContentView.prototype.viewAdded = function() {
	AREContentView.prototype.viewAdded.call(this);

	if (typeof google === 'object' && typeof google.maps === 'object' && navigator && navigator.onLine) {

		if (this.map) {
			var mapStyles =[{
				featureType: "poi",
				elementType: "labels",
				stylers: [{ visibility: "off" }]
			}];

			var coords = new google.maps.LatLng(this.articleData.latitude, this.articleData.longitude);

			var mapOptions = { zoom: 10, center: coords, mapTypeId: google.maps.MapTypeId.ROADMAP, disableDefaultUI: true, draggable:false, scrollwheel:false, styles:mapStyles};
			this.gmap = new google.maps.Map(this.map.html, mapOptions);

			this.marker = new AREMapMarker(this.gmap, "#ffffff", coords);
		}
	}
}