AREButton.prototype = new AREView();
AREButton.prototype.constructor = AREButton;

function AREButton(id) {
	this.performDefaultAction = true;
	this.touchReaction = true;
	this.touchResponder = null;
	this.buttonEnabled = true;

	AREView.prototype.constructor.call(this, id);
}

AREButton.prototype.init = function() {
	this.addViewClass("button");

	AREView.prototype.init.call(this);
}

AREButton.prototype.drawView = function() {
	AREView.prototype.drawView.call(this);

	this.touchResponder = new AREView();
	this.touchResponder.addViewClass("buttonTouchDown");
	this.addSubview(this.touchResponder);

	this.html.addEventListener('touchstart', $.proxy(this.touchResponseDown, this));
	this.html.addEventListener('mousedown', $.proxy(this.touchResponseDown, this));
	this.html.addEventListener('touchend', $.proxy(this.touchResponseUp, this));
	this.html.addEventListener('mouseup', $.proxy(this.touchResponseUp, this));
}

AREButton.prototype.touchResponseDown = function() {
	if (this.touchReaction && this.touchResponder && this.buttonEnabled) {
		$(this.touchResponder.html).css("visibility","visible");
	}
}

AREButton.prototype.touchResponseUp = function() {
	if (this.touchReaction && this.touchResponder && this.buttonEnabled) {
		$(this.touchResponder.html).css("visibility","hidden");
	}
}

AREButton.prototype.setButtonRadius = function(r) {
	$(this.touchResponder.html).css("border-radius",r.toString()+"px");
}

AREButton.prototype.setEnabled = function(b) {
	this.buttonEnabled = b;
	if (!b) {
		$(this.html).css("opacity","0.2");
	} else {
		$(this.html).css("opacity","1.0");
	}
}