ARECategoryContentView.prototype = new AREView();
ARECategoryContentView.prototype.constructor = ARECategoryContentView;

function ARECategoryContentView(obj) {
	this.categoryData = obj;
	this.categoryHeaderElement = null;
	this.categoryContentElement = null;
	this.tapToViewContainer = null;
	this.categoryContainer = null;
	this.imageContainer = null;
	this.sponsor = null;
	this.button = null;

	AREView.prototype.constructor.call(this);
}

ARECategoryContentView.prototype.drawView = function() {
	AREView.prototype.drawView.call(this);
	this.addViewClass("categoryContentView");

	this.categoryContainer = new AREView();
	this.categoryContainer.addViewClass("categoryContentContainer");
	this.addSubview(this.categoryContainer);

	this.imageContainer = new AREView();
	this.imageContainer.addViewClass("categoryImageContainer");
	this.imageContainer.setHtml("<img src='"+this.categoryData.image+"'>");
	this.categoryContainer.addSubview(this.imageContainer);

	this.categoryHeaderElement = new AREView(null, "h1");
	this.categoryHeaderElement.setHtml(this.categoryData.heading);
	this.categoryContainer.addSubview(this.categoryHeaderElement);

	this.categoryContentElement = new AREView(null, "p");
	this.categoryContentElement.setHtml(this.categoryData.body);
	this.categoryContainer.addSubview(this.categoryContentElement);

	if (this.categoryData.sponsorImage && this.categoryData.sponsorLink) {
		this.sponsor = new AREView();
		this.sponsor.addViewClass("categorySponsorContainer");
		this.sponsor.setHtml("<img onclick=\"window.open('"+this.categoryData.sponsorLink+"', '_blank', 'location=yes');\" src='"+this.categoryData.sponsorImage+"'>");
		this.categoryContainer.addSubview(this.sponsor);
	}

	this.tapToViewContainer = new AREView();
	this.tapToViewContainer.addViewClass("tapToViewContainer");
	this.imageContainer.addSubview(this.tapToViewContainer);

	var buttonTitle = "TAP TO VIEW";
	this.button = new AREButton();
	this.button.addViewClass("feedbackButton");
	this.button.setButtonRadius(50);
	this.tapToViewContainer.addSubview(this.button);

	var caption = new AREView();
	caption.addViewClass("feedbackButtonTitle");
	$(caption.html).append(buttonTitle);

	this.button.addSubview(caption);

	//$(this.categoryImageBackground.html).click($.proxy(this.sectionSelected, this));
	$(this.imageContainer.html).click($.proxy(this.sectionSelected, this));
	$(this.categoryHeaderElement.html).click($.proxy(this.sectionSelected, this));
	$(this.categoryContentElement.html).click($.proxy(this.sectionSelected, this));
	$(this.button.html).click($.proxy(this.sectionSelected, this));
}

ARECategoryContentView.prototype.sectionSelected = function() {
	$(this).trigger(ARECategoryContentViewEvent.SELECTED, [this.categoryData]);
}