AREMainMenuItem.prototype = new AREView();
AREMainMenuItem.prototype.constructor = AREMainMenuItem;

function AREMainMenuItem(t) {
	this.itemTitle = (t) ? t.toUpperCase() : "";
	this.headerView = null;
	this.subMenuView = null;
	this.isExpanded = false;
	this.subMenuItems = new Array();
	this.categoryObject = null;
	this.header = null;
	this.leftContainer = null;
	this.rightContainer = null;
	this.checkBox = null;
	this.itemHasCheckbox = false;

	AREView.prototype.constructor.call(this);
}

AREMainMenuItem.prototype.drawView = function() {
	AREView.prototype.drawView.call(this);
	this.addViewClass("mainMenuItem");

	this.headerView = new AREView();
	this.headerView.addViewClass("itemHeaderContainer");
	this.addSubview(this.headerView);

	this.leftContainer = new AREView();
	this.leftContainer.addViewClass("leftItemContainer");
	this.headerView.addSubview(this.leftContainer);
	this.leftContainer.width("0px");

	this.header = new AREView();
	this.header.addViewClass("itemHeader");
	var txt = this.itemTitle.replace(/(<([^>]+)>)/ig,"");
	$(this.header.html).html(txt);
	this.headerView.addSubview(this.header);

	this.rightContainer = new AREView();
	this.rightContainer.addViewClass("rightItemContainer");
	this.headerView.addSubview(this.rightContainer);
	this.rightContainer.setHidden(true);

	this.checkBox = new ARECheckBox();
	$(this.checkBox).bind(ARECheckboxEvent.STATE_CHANGED, $.proxy(this.checkBoxUpdated, this));
	this.rightContainer.addSubview(this.checkBox);

	this.subMenuView = new AREView();
	this.subMenuView.addViewClass("mainMenuSubItemsContainer");
	this.addSubview(this.subMenuView);

	$(this.header.html).click($.proxy(this.expand,this));
}

AREMainMenuItem.prototype.checkBoxUpdated = function() {
	$(this).trigger(ARECheckboxEvent.STATE_CHANGED, [this]);
}

AREMainMenuItem.prototype.hasColouredIcon = function(c) {
	if (this.leftContainer) {
		this.leftContainer.width("6%");
		$(this.leftContainer.html).css("background-color",c);
	}
}

AREMainMenuItem.prototype.hasCheckBox = function(c) {
	if (this.rightContainer) {
		this.itemHasCheckbox = c;
		this.rightContainer.setHidden(!c);
	}
}

AREMainMenuItem.prototype.enableLeftIcon = function() {
	if (this.leftContainer) {
		this.leftContainer.width("6%");
	}
}

AREMainMenuItem.prototype.expand = function() {
	if (this.subMenuItems.length > 0) {
		var subMenuHeight = $(this.subMenuView.html).height();

		if (this.isExpanded) {
			AREAnimation.to(this.html, 0.5, {height:"45px", ease:"Expo.easeOut", onComplete:$.proxy(this.subMenuHidden, this)});
		} else {
			$(this.subMenuView.html).css("top","40px");
			AREAnimation.to(this.html, 0.4, {height:(55+subMenuHeight).toString()+"px", ease:"Expo.easeInOut"});
		}

		this.isExpanded = !this.isExpanded;
	} else {
		$(this).trigger(AREMainMenuEvent.MAIN_MENU_ITEM_SELECTED, this);
	}
}

AREMainMenuItem.prototype.setActiveMenu = function(b) {
	if (b) {
		$(this.headerView.html).css("color","#f44650");
	} else {
		$(this.headerView.html).css("color","#ffffff");
	}
}

AREMainMenuItem.prototype.addSubMenuItem = function(t) {
	var item = new AREMainMenuSubItem(t);
	item.parentItem = this;
	this.subMenuView.addSubview(item);
	this.subMenuItems.push(item);

	return item;
}

AREMainMenuItem.prototype.subMenuHidden = function() {
	$(this.subMenuView.html).css("top","45px");
}