AREMainMenuSubItem.prototype = new AREView();
AREMainMenuSubItem.prototype.constructor = AREMainMenuSubItem;

function AREMainMenuSubItem(t) {
	this.itemTitle = (t) ? t : "";
	this.headerView = null;
	this.subCategoryObject = null;
	this.locationData = null;
	this.index = -1;
	this.rightContainer = null;
	this.checkBox = null;
	this.itemHasCheckbox = false;
	this.parentItem = null;

	AREView.prototype.constructor.call(this);
}

AREMainMenuSubItem.prototype.drawView = function() {
	AREView.prototype.drawView.call(this);
	
	this.addViewClass("subMenuItem");
	
	this.headerView = new AREView();
	this.headerView.addViewClass("subItemHeader");
	var txt = this.itemTitle.replace(/(<([^>]+)>)/ig,"");
	$(this.headerView.html).html(txt);
	this.addSubview(this.headerView);
	
	this.rightContainer = new AREView();
	this.rightContainer.addViewClass("rightItemContainer");
	this.addSubview(this.rightContainer);
	this.rightContainer.setHidden(true);
	
	this.checkBox = new ARECheckBox();
	//$(this.checkBox).bind(ARECheckboxEvent.STATE_CHANGED, $.proxy(this.checkBoxUpdated, this));
	this.rightContainer.addSubview(this.checkBox);
	
	$(this.html).click($.proxy(this.itemPressedEvent, this));
}

AREMainMenuSubItem.prototype.itemPressedEvent = function() {
	if (this.itemHasCheckbox) {
		this.checkBox.wasClicked();
	}
	$(this).trigger(ARESubMenuItemEvent.SUB_MENU_ITEM_SELECTED, [this]);
}

AREMainMenuSubItem.prototype.hasCheckBox = function(c) {
	if (this.rightContainer) {
		this.itemHasCheckbox = c;
		this.rightContainer.setHidden(!c);
	}
}