AREMapMarker.prototype = (typeof google === 'object' && typeof google.maps === 'object' && navigator && navigator.onLine) ? new google.maps.OverlayView() : new Object();

function AREMapMarker(map, color, coords, style, offset) {
	this.map = map;
	this.color = color;
	this.coords = coords;
	this.div = null;
	this.style = (style) ? style : "markerImage";
	this.offset = (offset) ? offset : {x:-10,y:-31};
	this.markerImage = null;
	this.markerIndicator = null;
	this.markerId = -1;
	this.ooeData = null;
	this.setMap(map);
}

AREMapMarker.prototype.onAdd = function() {
	this.div = document.createElement("div");
	$(this.div).addClass("mapMarker");

	if (this.style=="markerImage") {
		this.markerIndicator = document.createElement("div");
		$(this.markerIndicator).addClass("colourIndicator");
		$(this.markerIndicator).css("background-color",this.color);
	}

	this.markerImage = document.createElement("div");
	$(this.markerImage).addClass(this.style);

	if (this.markerIndicator) this.div.appendChild(this.markerIndicator);
	this.div.appendChild(this.markerImage);

	var panes = this.getPanes();
  	panes.overlayLayer.appendChild(this.div);

  	google.maps.event.addDomListener(this.div, 'click', $.proxy(this.markerPressed, this));
}

AREMapMarker.prototype.markerPressed = function() {
	google.maps.event.trigger(this, 'click', this);
}

AREMapMarker.prototype.draw = function() {
	var overlayProjection = this.getProjection();
	var position = overlayProjection.fromLatLngToDivPixel(this.coords);

  	this.div.style.left = (position.x+this.offset.x)+"px";
  	this.div.style.top = (position.y+this.offset.y)+"px";
}

AREMapMarker.prototype.onRemove = function() {
	this.div.parentNode.removeChild(this.div);
	this.div = null;
	this.indicator = null;
}