AREMenuView.prototype = new AREView();
AREMenuView.prototype.constructor = AREMenuView;

function AREMenuView() {
	this.scrollView = null;
	this.menuItems = new Array();
	this.subMenuItems = new Array();
	
	this.oldScrollView = null;
	this.oldMenuItems = new Array();
	this.oldSubMenuItems = new Array();

	AREView.prototype.constructor.call(this);
}

AREMenuView.prototype.drawView = function() {
	AREView.prototype.drawView.call(this);
	
	this.scrollView = new AREScrollView();
	this.scrollView.addViewClass("mainMenuView");
	this.addSubview(this.scrollView);
	
	var menuWidth = $(window).width()*0.3;
	menuWidth = (menuWidth < 270) ? "270px" : Math.round(menuWidth).toString()+"px";
	
	$(this.scrollView.html).css("width",menuWidth);
}

AREMenuView.prototype.createNewMenu = function() {
	this.oldScrollView = this.scrollView;
	this.oldMenuItems = this.menuItems;
	this.oldSubMenuItems = this.subMenuItems;
	
	for (var i=0; i<this.oldMenuItems.length; i++) {
		$(this.oldMenuItems[i]).unbind();
	}
	
	for (var i=0; i<this.oldSubMenuItems.length; i++) {
		$(this.oldSubMenuItems[i]).unbind();
	}
	
	this.menuItems = new Array();
	this.subMenuItems = new Array();
	
	this.scrollView = new AREScrollView();
	this.scrollView.addViewClass("mainMenuView");
	this.addSubview(this.scrollView);
	
	var menuWidthNum = $(window).width()*0.3;
	menuWidthNum = (menuWidthNum < 270) ? 270 : Math.round(menuWidthNum);
	var menuWidth = menuWidthNum.toString()+"px";
	
	this.scrollView.x((0-menuWidthNum).toString()+"px");
	
	$(this.scrollView.html).css("width",menuWidth);
}

AREMenuView.prototype.animateNewMenu = function() {
	AREAnimation.to(this.scrollView.html, 0.6, {left:"0px", ease:"Expo.easeInOut", onComplete:$.proxy(this.clearOldMenu, this)});
}

AREMenuView.prototype.addMenuItem = function(t, a) {
	var item = new AREMainMenuItem(t);
	item.setActiveMenu(a);
	this.scrollView.addSubview(item);
	this.menuItems.push(item);
	
	return item;
}

AREMenuView.prototype.addSubMenuItemByIndex = function(i, t, a) {
	var mainMenuItem = this.menuItems[i];
	var item = null;

	if (mainMenuItem) {
		item = mainMenuItem.addSubMenuItem(t);
		this.subMenuItems.push(item);
		$(item).bind(ARESubMenuItemEvent.SUB_MENU_ITEM_SELECTED, $.proxy(this.subMenuItemSelected, this));
	}
	
	return item;
}

AREMenuView.prototype.addSubMenuItemTo = function(s, t, noEvent) {
	var item = null;

	if (s) {
		item = s.addSubMenuItem(t);
		this.subMenuItems.push(item);
		if (!noEvent) $(item).bind(ARESubMenuItemEvent.SUB_MENU_ITEM_SELECTED, $.proxy(this.subMenuItemSelected, this));
	}
	
	return item;
}

AREMenuView.prototype.clearMenu = function() {
	for (var i=0; i<this.menuItems.length; i++) {
		$(this.menuItems[i]).unbind();
		this.menuItems[i].removeFromSuperview();
	}
	
	this.menuItems = new Array();
	this.subMenuItems = new Array();
}

AREMenuView.prototype.clearOldMenu = function() {
	for (var i=0; i<this.oldMenuItems.length; i++) {
		$(this.oldMenuItems[i]).unbind();
		this.oldMenuItems[i].removeFromSuperview();
	}
	
	this.oldMenuItems = new Array();
	this.oldSubMenuItems = new Array();
	
	if (this.oldScrollView) { 
		this.oldScrollView.removeFromSuperview();
		this.oldScrollView = null;
	}
}

AREMenuView.prototype.subMenuItemSelected = function(e,i) {
	$(this).trigger(AREMainMenuEvent.MENU_ITEM_SELECTED, [i]);
}