AREModalView.prototype = new AREView();
AREModalView.prototype.constructor = AREModalView;

function AREModalView() {
	this.notifications = new Array();
	this.notificationDismissedHandler = $.proxy(this.notificationDismissed, this);
	this.currentView = null;

	AREView.prototype.constructor.call(this);
}

AREModalView.prototype.drawView = function() {
	AREView.prototype.drawView.call(this);
	this.setViewId("modalView");
}

AREModalView.prototype.displayNotification = function(n) {
	this.notifications.push(n);
	this.addSubview(n);
	this.displayModalView();
	
	$(n).bind(ARENotificationEvent.NOTIFICATION_DISMISSED, this.notificationDismissedHandler);
	n.display(true);
}

AREModalView.prototype.displayView = function(v) {
	if (this.currentView) { 
		this.currentView.removeFromSuperview();
		this.currentView = null;
	}
	this.currentView = v;
	this.addSubview(this.currentView);
	this.displayModalView();
}

AREModalView.prototype.removeCurrentView = function() {
	if (this.currentView) { 
		this.currentView.removeFromSuperview();
		this.currentView = null;
	}
	this.hideModalView();
}

AREModalView.prototype.notificationDismissed = function(e,n) {
	this.removeNotification(n);
}

AREModalView.prototype.removeNotification = function(n) {
	for (var i=0; i<this.notifications.length; i++) {
		if (this.notifications[i] == n) {
			this.notifications.splice(i, 1);
			n.removeFromSuperview();
			break;
		}
	}
	
	if (this.notifications.length <= 0) {
		this.hideModalView();
	}
}

AREModalView.prototype.displayModalView = function() {
	$(this.html).css({
		visibility : "visible",
		display : "block"
	});
}

AREModalView.prototype.hideModalView = function() {
	$(this.html).css({
		visibility : "hidden",
		display : "none"
	});
}

AREModalView.sharedInstance = null;