ARENotificationView.prototype = new AREView();
ARENotificationView.prototype.constructor = ARENotificationView;

function ARENotificationView(o) {
	this.dataObject = o;
	this.messageContainer = null;
	this.feedbackButton = null;
	this.messageHeading = null;
	this.messageBody = null;
	
	if (this.dataObject) {
		this.messageHeading = this.dataObject.heading;
		this.messageBody = this.dataObject.body;
	}

	AREView.prototype.constructor.call(this);
}

ARENotificationView.prototype.drawView = function() {
	AREView.prototype.drawView.call(this);
	this.addViewClass("notificationView");
	
	this.messageContainer = new AREView();
	this.messageContainer.addViewClass("messageContainer");
	this.addSubview(this.messageContainer);
	
	$(this.messageContainer.html).append("<h>"+this.messageHeading+"</h>");
	$(this.messageContainer.html).append("<div class='clear'></div>");
	$(this.messageContainer.html).append("<p>"+this.messageBody+"</p>");
	
	var buttonTitle = "OK";
	if (this.dataObject) {
		if (this.dataObject.button) {
			buttonTitle = this.dataObject.button;
		}
	}
	
	this.feedbackButton = new AREButton();
	this.feedbackButton.addViewClass("feedbackButton");
	this.feedbackButton.setButtonRadius(50);
	this.addSubview(this.feedbackButton);
	
	var caption = new AREView();
	caption.addViewClass("feedbackButtonTitle");
	$(caption.html).append(buttonTitle);
	
	this.feedbackButton.addSubview(caption);
	$(this.feedbackButton.html).click($.proxy(this.hide, this));
	
	this.hide(false);
}

ARENotificationView.prototype.display = function(a) {
	var notificationHeight = $(this.html).height();
	if (!a) {
		$(this.html).css({
			visibility : "visible",
			display : "block",
			top : "0px"
		});
	} else {
		$(this.html).css({
			visibility : "visible",
			display : "block"
		});
		AREAnimation.from(this.html, 0.6, {top:"-"+notificationHeight.toString()+"px", ease:"Expo.easeInOut"});
	}
}

ARENotificationView.prototype.hide = function(a) {
	var notificationHeight = $(this.html).height();
	if (!a) {
		$(this.html).css({
			visibility : "hidden",
			display : "none",
			top : "-"+notificationHeight.toString()+"px"
		});
	} else {
		AREAnimation.to(this.html, 0.6, {top:"-"+notificationHeight.toString()+"px", ease:"Expo.easeInOut", onComplete:$.proxy(this.notificationDismissed, this)});
	}
}

ARENotificationView.prototype.notificationDismissed = function() {
	var notificationHeight = $(this.html).height();
	$(this.html).css({
		visibility : "hidden",
		display : "none",
		top : "-"+notificationHeight.toString()+"px"
	});
	$(this).trigger(ARENotificationEvent.NOTIFICATION_DISMISSED, [this]);
}