AREOoePopupView.prototype = (typeof google === 'object' && typeof google.maps === 'object') ? new google.maps.OverlayView() : new Object();

function AREOoePopupView(map, coords, data, offset) {
	this.map = map;
	this.coords = coords;
	this.div = null;
	this.offset = (offset) ? offset : {x:0,y:0};
	this.data = data;
	this.setMap(map);
}

AREOoePopupView.prototype.onAdd = function() {
	this.div = document.createElement("div");
	$(this.div).addClass("popupView");

	$(this.div).css("min-height","110px");

  	var container = new AREView();
  	container.addViewClass("innerContainer");
  	$(container.html).css("min-height","90px");

  	/*var thumb = new AREView();
  	thumb.addViewClass("thumbnail");
  	$(thumb.html).css({backgroundImage:"url('"+this.data.thumbnail+"')"});
  	container.addSubview(thumb);*/

  	var header = new AREView();
  	header.addViewClass("header");
  	$(header.html).append(this.data.heading);
  	container.addSubview(header);

  	var body = new AREView();
  	body.addViewClass("body");
  	$(body.html).append(this.data.body);
  	container.addSubview(body);

  	var clear = new AREClear();
  	container.addSubview(clear);

  	var directionsBtn = new AREView();
		directionsBtn.addViewClass("button");

		var userCoords = User.sharedInstance.location;

		// console.log("User.sharedInstance.location = "); console.log(userCoords);

		var toLat = this.coords.lat();
		var toLng = this.coords.lng();

		if (userCoords) {
			var fromLat = userCoords.lat();
			var fromLng = userCoords.lng();

			var url = "https://maps.google.co.uk/maps?saddr="+fromLat+","+fromLng+"&daddr="+toLat+","+toLng;
		} else {
			var url = "https://maps.google.co.uk/maps?daddr="+toLat+","+toLng;
		}

		$(directionsBtn.html).append("<span onclick=\"window.open('"+url+"', '_blank', 'location=yes');\">Directions</span>");
		container.addSubview(directionsBtn);

  	var closeBtn = new AREView();
  	closeBtn.addViewClass("button");
  	$(closeBtn.html).append("Close");
  	container.addSubview(closeBtn);

  	$(this.div).append(container.html);

  	$(closeBtn.html).click($.proxy(this.closeButtonPressed, this));
  	$(directionsBtn.html).click($.proxy(this.directionsButtonPressed, this));

  	var panes = this.getPanes();
  	panes.overlayLayer.appendChild(this.div);
}

AREOoePopupView.prototype.closeButtonPressed = function() {
	$(this).trigger(AREPopupViewEvent.CLOSE_POPUP);
}

// AREOoePopupView.prototype.directionsButtonPressed = function() {
// 	$(this).trigger(AREPopupViewEvent.DISPAY_DIRECTIONS);
// }

AREOoePopupView.prototype.markerPressed = function() {
	google.maps.event.trigger(this, 'click', this);
}

AREOoePopupView.prototype.draw = function() {
	var overlayProjection = this.getProjection();
	var position = overlayProjection.fromLatLngToDivPixel(this.coords);

	var h = $(this.div).height();
	var w = $(this.div).width();

  	this.div.style.left = (position.x+this.offset.x-145)+"px";
  	this.div.style.top = (position.y+this.offset.y-h-5)+"px";
}

AREOoePopupView.prototype.onRemove = function() {
	this.div.parentNode.removeChild(this.div);
	this.div = null;
	this.indicator = null;
}