AREPageNavigationBarView.prototype = new AREView();
AREPageNavigationBarView.prototype.constructor = AREPageNavigationBarView;

function AREPageNavigationBarView() {
	this.backNavButton = null;

	this.leftContainer = null;
	this.centreContainer = null;
	this.rightContainer = null;

	this.rightNavButton = null;
	this.leftNavButton = null;
	this.menuNavButton = null;
	this.homeNavButton = null;
	this.gridNavButton = null;
	AREView.prototype.constructor.call(this);
}

AREPageNavigationBarView.prototype.drawView = function() {
	AREView.prototype.drawView.call(this);
	this.addViewClass("pageNavigationBarView");


	this.leftContainer = new AREView();
	this.leftContainer.addViewClass("leftContainer");
	this.addSubview(this.leftContainer);

	this.centreContainer = new AREView();
	this.centreContainer.addViewClass("centreContainer");
	this.addSubview(this.centreContainer);

	this.rightContainer = new AREView();
	this.rightContainer.addViewClass("rightContainer");
	this.addSubview(this.rightContainer);


	// Left container
	this.menuNavButton = new AREButton("pageNavigationMenuButton");
	this.menuNavButton.addViewClass("navigationButtonLeft");
	var icon = new AREView();
	icon.addViewClass("menuIcon");
	this.menuNavButton.addSubview(icon);
	this.leftContainer.addSubview(this.menuNavButton);

	this.gridNavButton = new AREButton("pageNavigationGridButton");
	this.gridNavButton.addViewClass("navigationButtonLeft");
	var icon = new AREView();
	icon.addViewClass("gridIcon");
	this.gridNavButton.addSubview(icon);
	this.leftContainer.addSubview(this.gridNavButton);

	// Centre container
	this.leftNavButton = new AREButton("pageNavigationLeftButton");
	this.leftNavButton.addViewClass("navigationButtonLeft");
	var icon = new AREView();
	icon.addViewClass("leftIcon");
	this.leftNavButton.addSubview(icon);
	this.centreContainer.addSubview(this.leftNavButton);

	this.rightNavButton = new AREButton("pageNavigationRightButton");
	this.rightNavButton.addViewClass("navigationButtonRight");
	var icon = new AREView();
	icon.addViewClass("rightIcon");
	this.rightNavButton.addSubview(icon);
	this.centreContainer.addSubview(this.rightNavButton);


	// Right Container
	this.homeNavButton = new AREButton("pageNavigationHomeButton");
	this.homeNavButton.addViewClass("navigationButtonRight");
	var icon = new AREView();
	icon.addViewClass("homeIcon");
	this.homeNavButton.addSubview(icon);
	this.rightContainer.addSubview(this.homeNavButton);

	this.backNavButton = new AREButton("pageNavigationBackButton");
	this.backNavButton.addViewClass("navigationButtonRight");
	var icon = new AREView();
	icon.addViewClass("backIcon");
	this.backNavButton.addSubview(icon);
	this.rightContainer.addSubview(this.backNavButton);


	$(this.menuNavButton.html).click($.proxy(this.menuButtonPressed, this));
	$(this.homeNavButton.html).click($.proxy(this.homeButtonPressed, this));
	$(this.leftNavButton.html).click($.proxy(this.leftButtonPressed, this));
	$(this.rightNavButton.html).click($.proxy(this.rightButtonPressed, this));
	$(this.backNavButton.html).click($.proxy(this.backButtonPressed, this));
	$(this.gridNavButton.html).click($.proxy(this.gridButtonPressed, this));
}

AREPageNavigationBarView.prototype.setNavigationEnabled = function(b) {
	if (b) {
		this.leftNavButton.setHidden(false);
		this.rightNavButton.setHidden(false);
	} else {
		this.leftNavButton.setHidden(true);
		this.rightNavButton.setHidden(true);
	}
}

AREPageNavigationBarView.prototype.setLeftNavigationEnabled = function(b) {
	this.leftNavButton.setEnabled(b);
}

AREPageNavigationBarView.prototype.setRightNavigationEnabled = function(b) {
	this.rightNavButton.setEnabled(b);
}

AREPageNavigationBarView.prototype.setHomeNavigationEnabled = function(b) {
	this.homeNavButton.setEnabled(b);
}

AREPageNavigationBarView.prototype.setBackNavigationEnabled = function(b) {
	this.backNavButton.setEnabled(b);
}

AREPageNavigationBarView.prototype.setGridNavigationEnabled = function(b) {
	this.gridNavButton.setEnabled(b);
}

AREPageNavigationBarView.prototype.menuButtonPressed = function() {
	$(this).trigger(AREPageNavigationBarEvent.MENU_BUTTON_PRESSED);
}

AREPageNavigationBarView.prototype.homeButtonPressed = function() {
	if (this.homeNavButton.buttonEnabled) $(this).trigger(AREPageNavigationBarEvent.HOME_BUTTON_PRESSED);
}

AREPageNavigationBarView.prototype.leftButtonPressed = function() {
	if (this.leftNavButton.buttonEnabled) $(this).trigger(AREPageNavigationBarEvent.NAVIGATE_LEFT);
}

AREPageNavigationBarView.prototype.rightButtonPressed = function() {
	if (this.rightNavButton.buttonEnabled) $(this).trigger(AREPageNavigationBarEvent.NAVIGATE_RIGHT);
}

AREPageNavigationBarView.prototype.backButtonPressed = function() {
	if (this.backNavButton.buttonEnabled) $(this).trigger(AREPageNavigationBarEvent.BACK_BUTTON_PRESSED);
}

AREPageNavigationBarView.prototype.gridButtonPressed = function() {
	if (this.gridNavButton.buttonEnabled) $(this).trigger(AREPageNavigationBarEvent.GRID_BUTTON_PRESSED);
}