AREPopupView.prototype = (typeof google === 'object' && typeof google.maps === 'object') ? new google.maps.OverlayView() : new Object();

function AREPopupView(map, coords, data, offset, inAdQueue) {
	this.map = map;
	this.coords = coords;
	this.div = null;
	this.offset = (offset) ? offset : {x:0,y:0};
	this.data = data;
	this.inAdQueue = (inAdQueue) ? true : false;
	this.setMap(map);
}

AREPopupView.prototype.onAdd = function() {
	this.div = document.createElement("div");
	$(this.div).addClass("popupView");

	var container = new AREView();
	container.addViewClass("innerContainer");

	var thumb = new AREView();
	thumb.addViewClass("thumbnail");
	$(thumb.html).css({backgroundImage:"url('"+this.data.thumbnail+"')"});
	container.addSubview(thumb);

	var header = new AREView();
	header.addViewClass("header");
	$(header.html).append(this.data.heading);
	container.addSubview(header);

	var body = new AREView();
	body.addViewClass("body");
	$(body.html).append(this.data.body);
	container.addSubview(body);

	var clear = new AREClear();
	container.addSubview(clear);

	var directionsBtn = new AREView();
	directionsBtn.addViewClass("button");

	var userCoords = User.sharedInstance.location;

	// console.log("User.sharedInstance.location = "); console.log(userCoords);

	// var toLat = this.coords.lat();
	// var toLng = this.coords.lng();

	// if (userCoords) {
	// 	var fromLat = userCoords.lat();
	// 	var fromLng = userCoords.lng();

	// 	var url = "https://maps.google.co.uk/maps?saddr="+fromLat+","+fromLng+"&daddr="+toLat+","+toLng;
	// } else {
	// 	var url = "https://maps.google.co.uk/maps?daddr="+toLat+","+toLng;
	// }

	// $(directionsBtn.html).append("<span onclick=\"window.open('"+url+"', '_blank', 'location=yes');\">Directions</span>");
	$(directionsBtn.html).append("Directions");
	container.addSubview(directionsBtn);

	$(directionsBtn.html).click($.proxy(this.directionsButtonPressed, this));

	if (!this.inAdQueue) {
		var viewMoreBtn = new AREView();
		viewMoreBtn.addViewClass("button");
		$(viewMoreBtn.html).append("View More");
		container.addSubview(viewMoreBtn);

		$(viewMoreBtn.html).click($.proxy(this.moreButtonPressed, this));
	}

	var closeBtn = new AREView();
	closeBtn.addViewClass("button");
	$(closeBtn.html).append("Close");
	container.addSubview(closeBtn);

	$(closeBtn.html).click($.proxy(this.closeButtonPressed, this));

	$(this.div).append(container.html);

	var panes = this.getPanes();
	panes.overlayLayer.appendChild(this.div);
}

AREPopupView.prototype.moreButtonPressed = function() {
	var ref = "location"+this.data.id.toString();
	$(this).trigger(AREPopupViewEvent.VIEW_MORE, [locationsArticleReference[ref]]);
}

AREPopupView.prototype.closeButtonPressed = function() {
	$(this).trigger(AREPopupViewEvent.CLOSE_POPUP);
}

// AREPopupView.prototype.directionsButtonPressed = function() {
// 	$(this).trigger(AREPopupViewEvent.DISPAY_DIRECTIONS);
// }

AREPopupView.prototype.directionsButtonPressed = function() {

	if (theAppIsBusy == true) return false;

	theAppIsBusy = true;
	setTimeout(function(){
		theAppIsBusy = false;
	}, 1000);

	var toLat = this.coords.lat();
	var toLng = this.coords.lng();

	var userCoords = User.sharedInstance.location;
	if (userCoords) {
		var fromLat = userCoords.lat();
		var fromLng = userCoords.lng();

		var url = "https://maps.google.co.uk/maps?saddr="+fromLat+","+fromLng+"&daddr="+toLat+","+toLng;
	} else {
		var url = "https://maps.google.co.uk/maps?daddr="+toLat+","+toLng;
	}

	window.open(url, '_blank', 'location=yes');
}

AREPopupView.prototype.markerPressed = function() {
	google.maps.event.trigger(this, 'click', this);
}

AREPopupView.prototype.draw = function() {
	var overlayProjection = this.getProjection();
	var position = overlayProjection.fromLatLngToDivPixel(this.coords);

	var h = $(this.div).height();
	var w = $(this.div).width();

  	this.div.style.left = (position.x+this.offset.x-145)+"px";
  	this.div.style.top = (position.y+this.offset.y-h-5)+"px";
}

AREPopupView.prototype.onRemove = function() {
	this.div.parentNode.removeChild(this.div);
	this.div = null;
	this.indicator = null;
}