ARESubCategoryPageView.prototype = new AREPage();
ARESubCategoryPageView.prototype.constructor = ARESubCategoryPageView;

function ARESubCategoryPageView(c) {
	this.category = c;
	this.featuredSection = null;
	this.subCategorySection = null;
	AREPage.prototype.constructor.call(this);
}

ARESubCategoryPageView.prototype.drawView = function() {
	AREPage.prototype.drawView.call(this);

	// console.log("SUB CATEGORY DRAW_VIEW CALLED");

	if (googleAnalytics && navigator && navigator.onLine) googleAnalytics.trackPage("application/categories/"+this.category.heading+"/");

	var section = new ARESubCategoryHeadingContentView(this.category);
	this.addContent(section);

	this.featuredSection = new ARESubCategoryGridView({title:"Featured"});
	this.addContent(this.featuredSection);

	this.subCategorySection = new ARESubCategoryGridView({title:"Sub Categories"});
	this.addContent(this.subCategorySection);

	this.featuredSection.setHidden(true);
	this.subCategorySection.setHidden(true);

	var featuredQueues = Array();

	for (var i = 0; i < this.category.subCategories.length; i++) {

		var subCategory = this.category.subCategories[i];

		var thumb = null;

		for (var k = 0; k < subCategory.advertQueues.length; k++) {

			// console.log("ADVERT QUEUE ["+k+"]");

			var queue = subCategory.advertQueues[k];

			if (queue.featured == true) {// && ( jQuery.inArray( queue, featuredQueues) >= 0) ) {
				// console.log("FEATURED ADVERT QUEUE ["+queue.json.id+"]");
				var instertit = true;
				for (var m = 0; m < featuredQueues.length; m++) {
					if ( featuredQueues[m].json.id == queue.json.id ) {
						instertit = false;
						// console.log("Repeated Featured AQ ["+queue.json.id+"]");
						break;
					}
					//featuredQueues[queue.json.id] = queue;
				}

				if (instertit == true) {
					// console.log("Non-Repeated Featured AQ ["+queue.json.id+"]");
					featuredQueues.push(queue);
				}
			}
		}

		thumb = this.subCategorySection.addThumb(subCategory);
		this.subCategorySection.setHidden(false);
		if (thumb) {
			$(thumb).bind(ARESubCategoryThumbViewEvent.SUB_CATEGORY_SELECTED, $.proxy(this.sectionSelectedEvent, this));
		}
	}

	featuredQueues = this.shuffleArray(featuredQueues);

	for (var i = 0; i < featuredQueues.length; i++) {
		var queue = featuredQueues[i];

		thumb = this.featuredSection.addThumb(queue);
		this.featuredSection.setHidden(false);
		if (thumb) {
			$(thumb).bind(ARESubCategoryThumbViewEvent.SUB_CATEGORY_SELECTED, $.proxy(this.sectionSelectedEvent, this));
		}
	}
}

ARESubCategoryPageView.prototype.sectionSelectedEvent = function(e, s) {

	// console.log("TRIGGERING SUB_CATEGORY_SELECTED EVENT with s = "); console.log(s);

	$(this).trigger(ARESubCategoryPageViewEvent.SUB_CATEGORY_SELECTED, [s]);
}

ARESubCategoryPageView.prototype.shuffleArray = function(array) {
	for (var i = array.length - 1; i > 0; i--) {
        var j = Math.floor(Math.random() * (i + 1));
        var temp = array[i];
        array[i] = array[j];
        array[j] = temp;
    }
    return array;
}