var AREView = function(id, el) {
	this.html = (!el) ? document.createElement("div") : document.createElement(el);
	$(this.html).addClass("view");
	if (id) $(this.html).attr("id",id);
	this.viewId = id;
	this.requiresViewUpdate = false;

	//if (displayList) displayList.push(this);

	this.init();
}

AREView.prototype.init = function() {
	this.drawView();
}

AREView.prototype.drawView = function() {

}

AREView.prototype.setHtml = function(h,a) {
	if (!a) {
		$(this.html).html(h);
	} else {
		$(this.html).append(h);
	}
}

AREView.prototype.setViewId = function(id) {
	if (id) $(this.html).attr("id",id);
	this.viewId = id;
}

AREView.prototype.getViewId = function() {
	return (this.viewId) ? "#"+this.viewId : null;
}

AREView.prototype.addViewClass = function(className) {
	if (className) $(this.html).addClass(className);
}

AREView.prototype.setViewClass = function(className) {
	$(this.html).removeClass();
	if (className) $(this.html).addClass(className);
}

AREView.prototype.setBackgroundColor = function(c) {
	$(this.html).css("background-color",c);
}

AREView.prototype.setHidden = function(b) {
	if (!b) {
		$(this.html).css({
			visibility : "visible",
			display : "block"
		});
	} else {
		$(this.html).css({
			visibility : "hidden",
			display : "none"
		});
	}
}

AREView.prototype.addSubview = function(v) {
	$(this.html).append(v.html);
	v.updateView();
}

AREView.prototype.removeSubview = function(v) {
	$(this.html).remove(v.html);
	v.destroy();
}

AREView.prototype.removeFromSuperview = function(d) {
	$(this.html).remove();
	if (!d) this.destroy();
}

AREView.viewWithElement = function(el) {
	var view = new AREView();
	view.html = el;
	$(view.html).addClass("view");
	if ($(el).attr("id")) view.viewId = $(el).attr("id");

	return view;
}

AREView.prototype.updateView = function() {

}

AREView.prototype.viewAdded = function() {

}

AREView.prototype.destroy = function() {
	this.html = null;
	delete this;
}

AREView.prototype.width = function(w) {
	if (w) $(this.html).css("width",w);
	return $(this.html).width();
}

AREView.prototype.height = function(h) {
	if (h) $(this.html).css("height",h);
	return $(this.html).height();
}

AREView.prototype.x = function(p) {
	if (p) $(this.html).css("left",p);
	return parseInt($(this.html).css("left"));
}

AREView.prototype.y = function(p) {
	if (p) $(this.html).css("top",p);
	return parseInt($(this.html).css("top"));
}

AREView.prototype.setBackground = function(l) {
	if (l) this.css({backgroundImage:"url("+l+")"});
}

AREView.prototype.setAttributes = function(a) {
	$(this.html).attr(a);
}

AREView.prototype.css = function(c) {
	if (c) $(this.html).css(c);
}